<?php

namespace App\controleur;

use App\gateway\Connection;
use App\gateway\ImageGateway;
use App\modele\Image;

class UtilisateurControleur
{
    public function __construct()
    {
        global $twig;
        if (!isset($_REQUEST["action"])) {
           //$action = NULL;
            $action = "CreerOffre";
        } else {
            $action = \App\config\Validation::nettoyerString($_REQUEST["action"]);
        }


        switch ($action) {
            case NULL:
            case "accueil":
                $this->accueil();
                break;
            case "connection":
                $this->connection();
                break;
            case "inscription":
                $this->inscription();
                break;
            case "consulterProfilLimite":
                $this->consulterProfilLimite();
                break;
            case "CreerOffre":
                //echo "test";
                $this->creerOffre();
                break;
            case "publierOffre":
                $this->publierOffre();
                break;
            default:
                $dVueErreur[] ="Action inconnue ou non autorisée";
                echo $twig->render("erreur.html",['dVueErreur' => $dVueErreur]);

        }
    }

    protected function connection()
    {
        global $twig;
        echo $twig->render('connexion.html', []);
    }

    protected function inscription()
    {
        global $twig;
        $dVueErreur = []; // Tableau pour stocker les erreurs, le cas échéant

        if (isset($_POST['email'], $_POST['username'], $_POST['password'])) {
            $email = \App\config\Validation::nettoyerString($_POST['email']);
            $motDePasse = \App\config\Validation::nettoyerString($_POST['password']);


            // Validez les données d'inscription, par exemple, vérifiez si l'email est unique
            // Vous pouvez également effectuer d'autres validations nécessaires

            $userModel = new \App\modele\UtilisateurModele();
            $nouvelUtilisateur = $userModel->inscription($email, $motDePasse);

            // Si l'inscription a réussi, redirigez l'utilisateur vers une page de confirmation
            // Vous pouvez également gérer les erreurs ici en cas d'échec de l'inscription

            if ($nouvelUtilisateur instanceof \App\modele\Alumni) {
                // L'inscription a réussi, redirigez l'utilisateur vers une page de confirmation
                // par exemple :
                header('Location: index.php?action=inscription_success');
                exit();
            } else {
                // L'inscription a échoué, ajoutez un message d'erreur
                $dVueErreur[] = "L'inscription a échoué, veuillez réessayer.";
            }
        }

        // Affichez le formulaire d'inscription ou les erreurs le cas échéant
        echo $twig->render('inscription.html', ['dVueErreur' => $dVueErreur]);
    }

    protected function accueil()
    {
        global $twig;
        echo $twig->render('accueil.html', []);
    }

    protected function consulterProfilLimite()
    {
        //TODO
    }

    protected function creerOffre()
    {
        /*
        global $twig;
        echo $twig->render('testImage.html', []);
       /*
         * */
        $con = new Connection("mysql:host=localhost;dbname=dbAlica",'test','test');

        $imgGw = new ImageGateway($con);

        $imglist = $imgGw->getAll();

        //echo $imglist[0]->getBlob();
       // echo $imglist[0]->toString();

        echo '<img src="data:image/jpg;base64,' . base64_encode($imglist[0]->getBlob() ). '" height="100" width="100" alt="mon image" title="image"/>';

    }

    protected function publierOffre()
    {

        if(isset($_POST["submit"]))
            $img = new Image($_FILES["image"]["name"],
                $_FILES["image"]["size"],$_FILES["image"]["type"],file_get_contents($_FILES["image"]["tmp_name"]));
        else {
            echo "<h1>Image non inserée<h1>";
            return;
        }

        $con = new Connection("mysql:host=localhost;dbname=dbAlica",'test','test');

        $imgGw = new ImageGateway($con);

        $imgGw->insertImage($img);

        //echo $img->getBlob();
        // echo '<img src="data:image/jpg;base64,' . base64_encode($img->getBlob() ). '" height="100" width="100" alt="mon image" title="image"/>';

        echo "<h1>Image inserée<h1>";

    }


}